Sketcher Scripts

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Sketcher scripting and the translation is 100% complete.
Other languages:
Deutsch • ‎English • ‎español • ‎français • ‎polski

Créer une contrainte en Python

Une contrainte géométrique, Sketcher ConstrainCoincident.svg Sketcher ConstrainPointOnObject.svg Sketcher ConstrainVertical.svg Sketcher ConstrainHorizontal.svg Sketcher ConstrainParallel.svg Sketcher ConstrainPerpendicular.svg Sketcher ConstrainTangent.svg Sketcher ConstrainEqual.svg Sketcher ConstrainSymmetric.svg Sketcher ConstrainBlock.svg, et les contraintes spéciales Sketcher ConstrainInternalAlignment.svg d'alignement interne peuvent être créées à partir de macros et de la console Python en utilisant la commande suivante:

Sketch.addConstraint(Sketcher.Constraint(ConstraintType, EdgeOrPartOfEdge))

Une contrainte dimensionnelle, Sketcher ConstrainLock.svg Sketcher ConstrainDistanceX.svg Sketcher ConstrainDistanceY.svg Sketcher ConstrainDistance.svg Sketcher ConstrainRadius.svg Sketcher ConstrainDiameter.svg Sketcher ConstrainAngle.svg, et la contrainte spéciale Sketcher ConstrainSnellsLaw.svg Loi de Snell peuvent être créés à partir de macros et de la console Python en utilisant la commande suivante:

Sketch.addConstraint(Sketcher.Constraint(DimensionalConstraintType, EdgeOrPartOfEdge, App.Units.Quantity('float_value unit')))
e.g.
Sketch.addConstraint(Sketcher.Constraint(DimensionalConstraintType, EdgeOrPartOfEdge, App.Units.Quantity('123.0 mm')))

Le premier argument ConstraintType est décrit ci-dessous dans les Types de contraintes.

Une contrainte peut prendre jusqu'à six arguments qui sont des arêtes ou indiquent quelle sous-partie d'une arête est utilisée par la contrainte. Consultez la documentation des contraintes individuelles pour plus de détails sur les combinaisons d'arêtes et de sous-parties d'arêtes pouvant être passées en arguments. Le principal problème avec cette fonction est d'identifier correctement le numéro de ligne et le numéro de sommet des lignes que vous souhaitez traiter. Les sections ci-dessous décrivent comment identifier le numéro d'une ligne) et comment Identifier le numéro des sous-parties d'une ligne).

Types de contraintes

Pour les contraintes géométriques, le premier argument est l'un des suivants. Voir la page de fonctionnalités correspondante pour les combinaisons d'arguments possibles autorisées pour chaque contrainte.

Code Icon Feature
'Coincident' Sketcher ConstrainCoincident.svg Coincident
'PointOnObject' Sketcher ConstrainPointOnObject.svg Point On Object
'Vertical' Sketcher ConstrainVertical.svg Vertical
'Horizontal' Sketcher ConstrainHorizontal.svg Horizontal
'Parallel' Sketcher ConstrainParallel.svg Parallel
'Perpendicular' Sketcher ConstrainPerpendicular.svg Perpendicular
'Tangent' Sketcher ConstrainTangent.svg Tangent
'Equal' Sketcher ConstrainEqual.svg Equal
'Symmetric' Sketcher ConstrainSymmetric.svg Symmetric
'Block' Sketcher ConstrainBlock.svg Block

Les contraintes Sketcher ConstrainInternalAlignment.svg d'alignement internent se comportent comme des contraintes géométriques pour les besoins du script. Là encore, consultez la page de caractéristiques correspondante pour connaître les combinaisons possibles d'arguments autorisées pour chaque contrainte.

Code Icon Feature
'InternalAlignment:EllipseMajorDiameter' Sketcher ConstrainInternalAlignment.svg InternalAlignment
'InternalAlignment:EllipseMinorDiameter' Sketcher ConstrainInternalAlignment.svg InternalAlignment
'InternalAlignment:EllipseFocus1' Sketcher ConstrainInternalAlignment.svg InternalAlignment
'InternalAlignment:EllipseFocus2' Sketcher ConstrainInternalAlignment.svg InternalAlignment

Pour les contraintes dimensionnelles, le premier argument est l'un des suivants. Voir la page de fonctionnalités correspondante pour les combinaisons d'arguments possibles autorisées pour chaque contrainte.

Code Icon Feature
'DistanceX' Sketcher ConstrainDistanceX.svg Horizontal distance
'DistanceY' Sketcher ConstrainDistanceY.svg Vertical distance
'Distance' Sketcher ConstrainDistance.svg Distance
'Radius' Sketcher ConstrainRadius.svg Radius
'Diameter' Sketcher ConstrainDiameter.svg Diameter
'Angle' Sketcher ConstrainAngle.svg Angle
'AngleViaPoint' Sketcher ConstrainAngle.svg Angle

Les contraintes Sketcher ConstrainSnellsLaw.svg Loi de Snell se comportent comme des contraintes dimensionnelles pour les besoins du script. Encore une fois, consultez la page de fonctionnalités correspondante pour les combinaisons d'arguments possibles autorisées pour chaque contrainte.

Code Icon Feature
'SnellsLaw' Sketcher ConstrainSnellsLaw.svg Snell's law

La contrainte Sketcher ConstrainLock.svg fixe est une commande de l'interface graphique qui crée une contrainte Sketcher ConstrainDistanceX.svg distance horizontale et une Sketcher ConstrainDistanceY.svg distance verticale, ce n'est pas une contrainte en soi.

Identifier le numéro d'une ligne

J'ai dessiné trois lignes comme indiqué dans la figure suivante.

PartDesignConstraintPointOnPointScriptingFigure1.jpg

En déplaçant le curseur de la souris au-dessus de la ligne, vous pouvez voir le numéro de la ligne en bas à gauche des fenêtres FreeCAD, voir la figure suivante.

PartDesignConstraintPointOnPointScriptingFigure2.jpg

Malheureusement la numérotation affichée sur les fenêtres de FreeCAD commence à partir de 1 alors que la numérotation de la ligne utilisée pour le script commence à partir de 0: cela signifie que vous devez soustraire un à chaque fois que vous voulez faire référence à une ligne.

Les nombres positifs indiquent les arêtes d'esquisse (lignes droites, cercles, coniques, B-splines, etc.). Les valeurs suivantes peuvent être utilisées pour désigner des éléments qui ne sont pas des arêtes d'esquisse:

  • -1 désigne l'axe horizontal des x
  • -2 désigne l'axe vertical y
  • -n désigne le numéro de l'élément de géométrie externe n-3 (par exemple, l'élément de géométrie externe avec l'indice 0 dans la liste aplatie App.ActiveDocument.Sketch.ExternalGeometry serait désigné par -3, l'élément suivant dans la liste aplatie serait -4 et ainsi de suite).

Identifier le numéro des sous-parties d'une ligne

Pour déterminer quelle partie d'une ligne est affectée par une contrainte, les valeurs suivantes peuvent être utilisées :

  • 0 pour indiquer que la contrainte affecte tout le bord.
  • 1 pour indiquer que la contrainte affecte le point de départ du bord (un cercle entier n'a pas de point de départ).
  • 2 pour indiquer que la contrainte affecte le point final du bord.
  • 3 pour indiquer que la contrainte affecte le point central de l'arête. Pour des Sketcher CompCreateCircle.pngCercles et des Sketcher CompCreateConic.pngConiques (ellipses), c'est le centre du cercle ou le centre (intersection des grands et petits axes) de l'ellipse. Pour des Sketcher CreateLine.svgdroites, 3 ne peut pas être utilisé pour indiquer le point central.
  • n pour indiquer que la contrainte affecte le n-ième pôle d'une Sketcher CompCreateBSpline.pngB-Spline.

Les sommets indiqués par 1 et 2 sont numérotés selon leur ordre de création. Pour connaître l'ordre de leur création (si vous avez beaucoup de lignes, vous ne vous souvenez plus quel sommet vous avez créé en premier), il vous suffit de déplacer le curseur de votre souris au-dessus des deux sommets d'une ligne, voir figure suivante.

PartDesignConstraintPointOnPointScriptingFigure3.jpg

Si vous lisez par exemple 4 et 5, cela signifie que le sommet avec le numéro le plus bas (4 dans cet exemple) sera référencé en utilisant le numéro 1 (en premier dans la commande de script et le sommet avec le numéro le plus élevé (5 dans cet exemple) sera référencé par en utilisant le numéro 2 dans la commande de script.

Exemple

Prenons l'exemple précédent des trois lignes. La figure suivante indique la numérotation de chaque ligne et de leurs sommets selon la convention de script.

PartDesignConstraintPointOnPointScriptingFigure3Bis.jpg

blue text: numéro de ligne, black text: numéro de sommets

La commande Sketch.addConstraint(Sketcher.Constraint('Coincident',1,2,2,1)) donne le résultat suivant:

PartDesignConstraintPointOnPointScriptingFigure4.jpg

La commande Sketch.addConstraint(Sketcher.Constraint('Coincident',0,2,2,2)) donne le résultat suivant:

PartDesignConstraintPointOnPointScriptingFigure5.jpg